Package: et.nwfva
Title: Forest Yield Tables for Northwest Germany and their Application
Version: 0.2.0
Authors@R: c(
  person("Robert", "Nuske", role=c("aut", "cre"), 
         email="robert.nuske@mailbox.org", 
         comment=c(ORCID="0000-0001-9773-2061")),
  person("Kai", "Staupendahl", role="aut",
         comment=c(ORCID="0000-0001-6595-3601")),
  person("Matthias", "Albert", role="aut",
         comment=c(ORCID="0000-0003-0344-4806")),
  person("Nordwestdeutsche Forstliche Versuchsanstalt (NW-FVA)", 
         role=c("cph", "fnd")))
Description: The new yield tables developed by the Northwest German Forest 
  Research Institute (NW-FVA) provide a forest management tool for the five 
  main commercial tree species oak, beech, spruce, Douglas-fir and pine for 
  northwestern Germany. The new method applied for deriving yield tables 
  combines measurements of growth and yield trials with growth simulations 
  using a state-of-the-art single-tree growth simulator. By doing so, the new 
  yield tables reflect the current increment level and the recommended 
  graduated thinning from above is the underlying management concept. The yield
  tables are provided along with methods for deriving the site index and for 
  interpolating between age and site indices and extrapolating beyond age and 
  site index ranges. The inter-/extrapolations are performed traditionally by 
  the rule of proportion or with a functional approach.
Depends: R (>= 3.5)
Suggests: knitr, rmarkdown, tinytest
License: MIT + file LICENSE
URL: https://github.com/rnuske/et.nwfva
BugReports: https://github.com/rnuske/et.nwfva/issues
Encoding: UTF-8
Language: de
NeedsCompilation: no
RoxygenNote: 7.3.1
VignetteBuilder: knitr
Packaged: 2025-03-02 21:55:45 UTC; rnuske
Author: Robert Nuske [aut, cre] (<https://orcid.org/0000-0001-9773-2061>),
  Kai Staupendahl [aut] (<https://orcid.org/0000-0001-6595-3601>),
  Matthias Albert [aut] (<https://orcid.org/0000-0003-0344-4806>),
  Nordwestdeutsche Forstliche Versuchsanstalt (NW-FVA) [cph, fnd]
Maintainer: Robert Nuske <robert.nuske@mailbox.org>
Repository: CRAN
Date/Publication: 2025-03-02 22:10:01 UTC
Built: R 4.3.3; ; 2025-03-02 23:47:31 UTC; unix

Package: et.nwfva
Title: Forest Yield Tables for Northwest Germany and their Application
Version: 0.2.0
Authors@R: c(
  person("Robert", "Nuske", role=c("aut", "cre"), 
         email="robert.nuske@mailbox.org", 
         comment=c(ORCID="0000-0001-9773-2061")),
  person("Kai", "Staupendahl", role="aut",
         comment=c(ORCID="0000-0001-6595-3601")),
  person("Matthias", "Albert", role="aut",
         comment=c(ORCID="0000-0003-0344-4806")),
  person("Nordwestdeutsche Forstliche Versuchsanstalt (NW-FVA)", 
         role=c("cph", "fnd")))
Description: The new yield tables developed by the Northwest German Forest 
  Research Institute (NW-FVA) provide a forest management tool for the five 
  main commercial tree species oak, beech, spruce, Douglas-fir and pine for 
  northwestern Germany. The new method applied for deriving yield tables 
  combines measurements of growth and yield trials with growth simulations 
  using a state-of-the-art single-tree growth simulator. By doing so, the new 
  yield tables reflect the current increment level and the recommended 
  graduated thinning from above is the underlying management concept. The yield
  tables are provided along with methods for deriving the site index and for 
  interpolating between age and site indices and extrapolating beyond age and 
  site index ranges. The inter-/extrapolations are performed traditionally by 
  the rule of proportion or with a functional approach.
Depends: R (>= 3.5)
Suggests: knitr, rmarkdown, tinytest
License: MIT + file LICENSE
URL: https://github.com/rnuske/et.nwfva
BugReports: https://github.com/rnuske/et.nwfva/issues
Encoding: UTF-8
Language: de
NeedsCompilation: no
RoxygenNote: 7.3.1
VignetteBuilder: knitr
Packaged: 2025-03-02 21:55:45 UTC; rnuske
Author: Robert Nuske [aut, cre] (<https://orcid.org/0000-0001-9773-2061>),
  Kai Staupendahl [aut] (<https://orcid.org/0000-0001-6595-3601>),
  Matthias Albert [aut] (<https://orcid.org/0000-0003-0344-4806>),
  Nordwestdeutsche Forstliche Versuchsanstalt (NW-FVA) [cph, fnd]
Maintainer: Robert Nuske <robert.nuske@mailbox.org>
Repository: CRAN
Date/Publication: 2025-03-02 22:10:01 UTC
Built: R 4.6.0; ; 2026-04-25 18:42:22 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

# et.nwfva

<!-- badges: start -->

[![R-CMD-check](https://github.com/rnuske/et.nwfva/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/rnuske/et.nwfva/actions/workflows/R-CMD-check.yaml)
[![Package-License](https://img.shields.io/badge/license-GPL--2-brightgreen.svg?style=flat)](https://www.gnu.org/licenses/gpl-2.0.html)
[![CRAN](https://www.r-pkg.org/badges/version/et.nwfva)](https://cran.r-project.org/package=et.nwfva)
[![Dependencies](https://tinyverse.netlify.app/badge/et.nwfva)](https://cran.r-project.org/package=et.nwfva)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.7207596.svg)](https://doi.org/10.5281/zenodo.7207596)

<!-- badges: end -->

Die neuen Ertragstafeln der NW-FVA (Albert et al. 2021) bieten für die
fünf Hauptbaumarten Eiche, Buche, Fichte, Douglasie und Kiefer ein
Planungsinstrument, welches das aktuelle Zuwachsniveau der Wälder
Nordwestdeutschlands widerspiegelt und das empfohlene waldbauliche
Behandlungskonzept einer gestaffelten Hochdurchforstung unterstellt.

Neben den Tafelwerten bietet `et.nwfva` sowohl die Möglichkeit zu
bonitieren als auch Bestandeshöhen und Tafelwerte für beliebige
Bonitäten und Alter zu bestimmen. Für die Inter- und Extrapolation
kommen standardmäßig funktionale Bonitätsfächer zum Einsatz, aber die
klassische Methode mittels Dreisatz steht ebenfalls zur Verfügung. Die
funktionale Interpolation kann den Bereich von der -3. bis 7.
Ertragsklasse und den gesamten Altersbereich bedienen. Die klassische
Interpolation ist auf den Bonitätsbereich -2. bis 4. Ertragsklasse und
den Altersbereich 5 bis max. zulässiges Alter (Ei 220, Bu 180 und Fi,
Dgl, Ki 160) beschränkt.

<img src="man/figures/README-faecher-1.png" width="50%" /><img src="man/figures/README-faecher-2.png" width="50%" />

## Installation

Die aktuelle Version des Paketes kann für die gängigen Betriebssysteme
(Windows, Linux, macOS) von CRAN

``` r
install.packages("et.nwfva")
```

und aus dem [R-Universe der NW-FVA](https://nw-fva.r-universe.dev)
installiert werden.

``` r
# NW-FVA Universe in R bekannt machen
options(repos = c(
  nwfva = "https://nw-fva.r-universe.dev",
  CRAN = "https://cloud.r-project.org"))

# und Paket wie gewohnt installieren
install.packages("et.nwfva")
```

Die Entwicklerversion kann mit dem Paket `remotes` direkt aus
[Github](https://github.com/rnuske/et.nwfva) kompiliert und installiert
werden.

``` r
remotes::install_github("rnuske/et.nwfva")
```

## Beispiele

Einen Überblick über die vorhandenen Tafeln liefert `et_liste()` und
Detailinformationen zu einer Tafel `et_info()`. Ganze Tafeln einer
Baumart oder Auszüge aus einer Tafel, z.B. für bestimmte Bonitäten oder
Alter, bietet `et_tafel()`.

``` r
library(et.nwfva)

# Ertragstafelwerte für Buche 1. Ertragsklasse ausgeben (hier: Zeilen 1 bis 6)
head(et_tafel("Buche", bon=1))
#>   Ekl Alter    N   Hg H100    G   Dg   Dw   V N_aus G_aus Dg_aus V_aus   iV GWL dGZ
#> 1   1    35 3028  9.7 12.9 13.2  7.5 11.2  54  1518   5.5    6.8    24  9.5 111 3.2
#> 2   1    40 2083 12.3 15.3 15.2  9.7 14.4  82   945   4.9    8.1    28 11.1 167 4.2
#> 3   1    45 1487 14.7 17.5 16.9 12.0 17.7 112   596   4.4    9.7    31 12.2 228 5.1
#> 4   1    50 1104 16.9 19.5 18.3 14.5 21.1 143   382   4.1   11.7    34 13.0 293 5.9
#> 5   1    55  879 18.9 21.4 19.6 16.8 24.5 174   225   3.9   14.9    36 13.5 361 6.6
#> 6   1    60  721 20.7 23.1 20.8 19.1 27.8 206   159   3.7   17.2    38 13.9 430 7.2


# Eine Ertragstafelzeile interpoliert für Fichte 2.4. Ekl. und Alter 82
et_tafel("Fi", bon=2.4, alter=82)
#>   Ekl Alter   N   Hg H100    G   Dg   Dw     V N_aus G_aus Dg_aus V_aus   iV   GWL dGZ
#> 1 2.4    82 672 25.3 26.3 39.1 27.4 38.9 436.8    42     3   30.1  32.8 12.9 768.6 9.4
```

Die Bonitierung von Beständen erfolgt mit `et_bonitaet()` anhand von
Bestandesalter und -höhe standardmäßig über funktionale Bonitätsfächer.
Auf Wunsch ist auch die klassische Bonitierung mittels Dreisatz
verfügbar. Im Fall der Interpolation zwischen den Tafelwerten
unterscheiden sich die Verfahren kaum, aber im Extrapolationsbereich
können die Abweichungen durchaus beachtlich sein (siehe Abbildung oben).

``` r

# Ertragsklasse eines 80 jährigen Eichenbestandes mit der Mittelhöhe 16m
et_bonitaet("Eiche", alter=80, hoehe=16)
#> [1] 3.8
et_bonitaet("Eiche", alter=80, hoehe=16, methode="klassisch")
#> [1] 3.9
```

Sollte im Hinblick auf das Alter und/oder die Bestandeshöhe eine
Extrapolation der Tafelwerte notwendig sein, gibt die klassische Methode
einen Hinweis aus. Falls dabei der zulässige Extrapolationsbereich
verlassen würde, geben beide Methoden eine Warnung und je nach Wert des
Parameters `kapp_na` den jeweiligen Grenzwert oder `NA` zurück.

``` r
# Ertragsklasse eines 120 jährigen Kiefernbestandes mit Oberhöhe 32m
et_bonitaet("Kiefer", alter=120, hoehe=45, hoehe_typ="ober", methode="funktional")
#> [1] -2.4
et_bonitaet("Kiefer", alter=120, hoehe=45, hoehe_typ="ober", methode="klassisch")
#> Für die Ertragsklasse(n) '-1' ist das höchste Alter in der Tafel '90'. Es wurde auf das Alter '120' extrapoliert.
#> [1] -1.8

# Anfrage außerhalb des zulässigen Bonitätsbereichs
et_bonitaet("Kiefer", alter=70, hoehe=40, hoehe_typ="ober")
#> Warning: Die Bestandeshöhe 40 im Alter 70 ergibt eine Bonität außerhalb des Intervalls
#> [-3,7]. Da kapp_na=TRUE, wurde die Bonität auf NA gesetzt.
#> [1] NA
```

Die Bestandeshöhenwerte für die Abbildungen oben wurden mit der Funktion
`et_hoehe()` berechnet. Umrechnungen von relativen Ertragsklassen in
absolute Oberhöhenbonitäten (Oberhöhe H100 im Alter 100 in Metern) und
umgekehrt ermöglicht die Funktion `et_bontrans()`.

``` r
# Bestandesmittelhöhe für Buche im Alter 75 und 1.25. Ekl.
et_hoehe("bu", alter=75, bon=1.25, hoehe_typ="mittel")
#> [1] 24.4
et_hoehe("bu", alter=75, bon=1.25, hoehe_typ="mittel", methode="klass")
#> [1] 24.4


# Umrechnung von der Oberhöhenbonität 27 zur relativen Ertragsklasse für Kiefer
et_bontrans("Kiefer", bon=27, richtung="abs_zu_rel")
#> [1] 1.5
```

## Literatur

Albert M., Nagel J., Schmidt M., Nagel R.-V., Spellmann H. (2021): Eine
neue Generation von Ertragstafeln für Eiche, Buche, Fichte, Douglasie
und Kiefer \[Datensatz\]. Version 1.0. Zenodo.
<https://doi.org/10.5281/zenodo.6343906>

## ----tabelle1_html, echo=FALSE, results="asis"--------------------------------
cat('
<table class="table" style="margin-left: auto; margin-right: auto;">
<caption>Datengrundlage für die Ertragstafelerstellung für die fünf Hauptbaumarten: Anzahl der generierten Modellbestände mit ihren Alters- und Oberhöhenbonitätskennwerten. Die Anzahl ergibt
sich aus der in Klammern angegebenen Anzahl von Versuchsparzellen multipliziert mit den verwendeten Aufnahmen abzüglich ausgesonderter Startkonstellationen.</caption>
 <thead>
<tr>
<th style="empty-cells: hide;border-bottom:hidden;" colspan="1"></th>
<th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="1"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Anzahl</div></th>
<th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="3"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Alter zu Beginn der Projektion</div></th>
<th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="3"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Oberhöhenbonität h<sub>100</sub></div></th>
</tr>
  <tr>
   <th style="text-align:left;">   </th>
   <th style="text-align:center;"> Modellbestände </th>
   <th style="text-align:center;"> Min. </th>
   <th style="text-align:center;"> Mittelwert </th>
   <th style="text-align:center;"> Max. </th>
   <th style="text-align:center;"> 5% Quantil </th>
   <th style="text-align:center;"> Mittelwert </th>
   <th style="text-align:center;"> 95% Quantil </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;font-weight: bold;"> Eiche </td>
   <td style="text-align:center;"> 463 (101) </td>
   <td style="text-align:center;"> 17 </td>
   <td style="text-align:center;"> 74 </td>
   <td style="text-align:center;"> 170 </td>
   <td style="text-align:center;"> 19.4 </td>
   <td style="text-align:center;"> 27.3 </td>
   <td style="text-align:center;"> 36.4 </td>
  </tr>
  <tr>
   <td style="text-align:left;font-weight: bold;"> Buche </td>
   <td style="text-align:center;"> 241 (61) </td>
   <td style="text-align:center;"> 25 </td>
   <td style="text-align:center;"> 63 </td>
   <td style="text-align:center;"> 110 </td>
   <td style="text-align:center;"> 26.7 </td>
   <td style="text-align:center;"> 33.1 </td>
   <td style="text-align:center;"> 40.4 </td>
  </tr>
  <tr>
   <td style="text-align:left;font-weight: bold;"> Fichte </td>
   <td style="text-align:center;"> 278 (61) </td>
   <td style="text-align:center;"> 19 </td>
   <td style="text-align:center;"> 42 </td>
   <td style="text-align:center;"> 99 </td>
   <td style="text-align:center;"> 30.1 </td>
   <td style="text-align:center;"> 37.9 </td>
   <td style="text-align:center;"> 42.2 </td>
  </tr>
  <tr>
   <td style="text-align:left;font-weight: bold;"> Douglasie </td>
   <td style="text-align:center;"> 478 (290) </td>
   <td style="text-align:center;"> 15 </td>
   <td style="text-align:center;"> 40 </td>
   <td style="text-align:center;"> 77 </td>
   <td style="text-align:center;"> 35.1 </td>
   <td style="text-align:center;"> 41.7 </td>
   <td style="text-align:center;"> 47.8 </td>
  </tr>
  <tr>
   <td style="text-align:left;font-weight: bold;"> Kiefer </td>
   <td style="text-align:center;"> 142 (32) </td>
   <td style="text-align:center;"> 16 </td>
   <td style="text-align:center;"> 43 </td>
   <td style="text-align:center;"> 96 </td>
   <td style="text-align:center;"> 24.9 </td>
   <td style="text-align:center;"> 30.6 </td>
   <td style="text-align:center;"> 35.7 </td>
  </tr>
</tbody>
</table>
')

## ----tabelle2_html, echo=FALSE, results="asis"--------------------------------
cat('
<table class="kable_wrapper lightable-paper" style=\'font-family: "Arial Narrow", arial, helvetica, sans-serif; margin-left: auto; margin-right: auto;\'>
<caption>Die absoluten Oberhöhenbonitäten in den Ertragstafeln und die korrespondierenden relativen Ertragsklassen (gerundet) nach Schober (1995).</caption>
<tbody>
  <tr>
   <td> 

<table>
 <thead>
<tr><th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="2"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Eiche</div></th></tr>
  <tr>
   <th style="text-align:center;"> H<sub>100</sub> </th>
   <th style="text-align:center;"> Ekl. </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:center;"> 33 </td>
   <td style="text-align:center;"> -I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 30 </td>
   <td style="text-align:center;"> 0 </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 27 </td>
   <td style="text-align:center;"> I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 24 </td>
   <td style="text-align:center;"> II </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 21 </td>
   <td style="text-align:center;"> III </td>
  </tr>
</tbody>
</table>

 </td>
   <td> 

<table>
 <thead>
<tr><th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="2"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Buche</div></th></tr>
  <tr>
   <th style="text-align:center;"> H<sub>100</sub> </th>
   <th style="text-align:center;"> Ekl. </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:center;"> 40.5 </td>
   <td style="text-align:center;"> -I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 36.5 </td>
   <td style="text-align:center;"> 0 </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 32.5 </td>
   <td style="text-align:center;"> I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 28.5 </td>
   <td style="text-align:center;"> II </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 24.5 </td>
   <td style="text-align:center;"> III </td>
  </tr>
</tbody>
</table>

 </td>
   <td> 

<table>
 <thead>
<tr><th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="2"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Fichte</div></th></tr>
  <tr>
   <th style="text-align:center;"> H<sub>100</sub> </th>
   <th style="text-align:center;"> Ekl. </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:center;"> 43 </td>
   <td style="text-align:center;"> -I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 39 </td>
   <td style="text-align:center;"> 0 </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 35 </td>
   <td style="text-align:center;"> I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 31 </td>
   <td style="text-align:center;"> II </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 27 </td>
   <td style="text-align:center;"> III </td>
  </tr>
</tbody>
</table>

 </td>
   <td> 

<table>
 <thead>
<tr><th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="2"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Douglasie</div></th></tr>
  <tr>
   <th style="text-align:center;"> H<sub>100</sub> </th>
   <th style="text-align:center;"> Ekl. </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:center;"> &nbsp; </td>
   <td style="text-align:center;"> &nbsp; </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 50 </td>
   <td style="text-align:center;"> 0 </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 45 </td>
   <td style="text-align:center;"> I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 40 </td>
   <td style="text-align:center;"> II </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 35 </td>
   <td style="text-align:center;"> III </td>
  </tr>
</tbody>
</table>

 </td>
   <td> 

<table>
 <thead>
<tr><th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="2"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Kiefer</div></th></tr>
  <tr>
   <th style="text-align:center;"> H<sub>100</sub> </th>
   <th style="text-align:center;"> Ekl. </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:center;"> 37 </td>
   <td style="text-align:center;"> -I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 33 </td>
   <td style="text-align:center;"> 0 </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 29 </td>
   <td style="text-align:center;"> I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 25 </td>
   <td style="text-align:center;"> II </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 21 </td>
   <td style="text-align:center;"> III </td>
  </tr>
</tbody>
</table>

 </td>
  </tr>
</tbody>
</table>
')

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----setup, echo=FALSE--------------------------------------------------------
library(et.nwfva)

## ----et_bonitaet--------------------------------------------------------------
# Bonitätsschätzung: Ausgabe der relativen Ertragsklasse
et_bonitaet(art="Buche", alter=70, hoehe=29.1, hoehe_typ="ober")

## ----et_bontrans--------------------------------------------------------------
# Umrechnung von rel. Ertragsklasse in abs. Oberhöhenbonität
et_bontrans("bu", bon=0.18, richtung="rel_zu_abs")

## ----tafel-Interpolation------------------------------------------------------
et_tafel(art="Dgl", alter=37, bon=0.3)

## ----tafel_extrapolation------------------------------------------------------
et_tafel(art="Dgl", alter=140, bon=1.0)

## ----Beispiel_Abbildung, fig.width=7, fig.height=5----------------------------

# Beispielhafte Abbildung des Zuwachses über dem Alter 
# laut Buchen-Ertragstafel für die -I. bis III. Ekl.

bu <- et_tafel(art="Bu")

plot(0, 0, type='n', xlim=c(20, 150),ylim=c(0, 20),
     xlab="Alter [a]", ylab="iV [m³/ha/a]")

grid(nx=NULL, ny=NULL, col="lightgray", lty="dotted")

lines(iV ~ Alter, data=bu[bu$Ekl == -1, ], col="black", lwd=2)
lines(iV ~ Alter, data=bu[bu$Ekl == 0, ], col="tan4",  lwd=2)
lines(iV ~ Alter, data=bu[bu$Ekl == 1, ], col="tan3",  lwd=2)
lines(iV ~ Alter, data=bu[bu$Ekl == 2, ], col="tan2",  lwd=2)
lines(iV ~ Alter, data=bu[bu$Ekl == 3, ], col="tan1",  lwd=2)

legend("bottomright", inset=0.01, box.lty=0,
       legend=c("-1. Ekl","0. Ekl", "1. Ekl", "2. Ekl","3. Ekl"),
       col=c("black","tan4", "tan3", "tan2", "tan1"), 
       lty=1, lwd=2, cex=0.8)

#===============================================================================
#
#  Teste Bestimmung der Bestandeshöhen mit et_hoehe()
#
#===============================================================================

#===============================================================================
#  Testet die Eingabe Validierung
#===============================================================================
expect_silent(et_hoehe(511, alter=80, bon=1.3))
expect_error(et_hoehe(511, alter="80", bon=1.3))
expect_error(et_hoehe(511, alter=TRUE, bon=1.3))
expect_error(et_hoehe(511, alter=80, bon="1.3"))
expect_error(et_hoehe(511, alter=80, bon=TRUE))

# Baumartencode als character übergeben
expect_equal(et_hoehe("511", alter=80, bon=1.5), 29.7)

# Alter als Fließkommazahl
expect_error(et_hoehe(511, alter=80.1, bon=1.5))


#===============================================================================
#  Testet die funktionalisierte Inter-/Extrapolation
#===============================================================================

# Teste Höhen-Ekl-Kombinationen, die bei der Tafelkonstruktion verwendet wurden
norm <-data.frame(
  Art = rep(c("ei", "bu", "fi", "dgl", "ki"), times=c(5, 5, 5, 4, 5)),
  H100 = c(33, 30, 27, 24, 21, 40.5, 36.5, 32.5, 28.5, 24.5, 43, 39, 35, 31, 27,
           50, 45, 40, 35, 37, 33, 29, 25, 21),
  Ekl = c(-1, 0, 1, 2, 3, -1, 0, 1, 2, 3, -1, 0, 1, 2, 3, 0, 1, 2, 3, -1, 0, 1, 2, 3))

ekl2h100  <- numeric(nrow(norm))
h1002h100 <- numeric(nrow(norm))

for(i in seq_len(nrow(norm))){
  ekl2h100[i] <- et_hoehe(norm[i, 'Art'], alter=100, bon=norm[i, 'Ekl'],
                           bon_typ='rel', hoehe_typ="ober", meth='funk')
  h1002h100[i] <- et_hoehe(norm[i, 'Art'], alter=100, bon=norm[i, 'H100'],
                           bon_typ='abs', hoehe_typ="ober", meth='funk')
}

expect_equal(norm$H100, ekl2h100)
expect_equal(norm$H100, h1002h100)

# Interpolation
expect_equal(et_hoehe('fi', alter=86, bon=2.3, bon_typ='rel', hoehe_typ='ober', meth='funk'),
             27.5)
expect_equal(et_hoehe('ei', alter=136, bon=0.6, bon_typ='rel', hoehe_typ='mittel', meth='funk'),
             30.9)
expect_equal(et_hoehe('bu', alter=76, bon=30.9, bon_typ='abs', hoehe_typ='ober', meth='funk'),
             26.1)
expect_equal(et_hoehe('ki', alter=81, bon=30.6, bon_typ='abs', hoehe_typ='mittel', meth='funk'),
             26.9)


# Extrapolation
# Bonität
expect_equal(et_hoehe('fi', alter=71, bon=-1.5, bon_typ='rel', hoehe_typ='mittel', meth='funk'),
             39.2)
expect_equal(et_hoehe('bu', alter=103, bon=41.7, bon_typ='abs', hoehe_typ='mittel', meth='funk'),
             40.2)
expect_equal(et_hoehe('ei', alter=133, bon=4.5, bon_typ='rel', hoehe_typ='ober', meth='funk'),
             19.6)
expect_equal(et_hoehe('dgl', alter=87, bon=22.0, bon_typ='abs', hoehe_typ='ober', meth='funk'),
             20.8)
# Alter
expect_equal(et_hoehe('dgl', alter=13, bon=2.4, bon_typ='rel', hoehe_typ='ober', meth='funk'),
             3.7)
expect_equal(et_hoehe('ki', alter=12, bon=25, bon_typ='abs', hoehe_typ='ober', meth='funk'),
             4.7)
expect_equal(et_hoehe('ei', alter=240, bon=1.3, bon_typ='rel', hoehe_typ='mittel', meth='funk'),
             34.4)
expect_equal(et_hoehe('fi', alter=140, bon=34.6, bon_typ='abs', hoehe_typ='mittel', meth='funk'),
             37.1)



# Vektorisiertes
expect_equal(et_hoehe(c('ei', 'bu', 'dgl'), alter=54, bon=1.3, bon_typ='rel',
                      hoehe_typ='ober', meth='funk'),
             c(18.9, 20.0, 31.9))
expect_equal(et_hoehe('fi', alter=seq(100,140,10), bon=34.6, bon_typ='abs',
                      hoehe_typ='mittel', meth='funk'),
             c(33.5, 34.7, 35.7, 36.4, 37.1))
expect_equal(et_hoehe('bu', alter=76, bon=seq(30.9,40,2), bon_typ='abs',
                      hoehe_typ='ober', meth='funk'),
             c(26.1, 28, 29.8, 31.7, 33.6))


# Außerhalb des Alters- & Bonitätsbereiches
# Alter > 0
expect_true(is.na(out <- et_hoehe('ei', alter=-1, bon=1.3, bon_typ='rel',
                                  hoehe_typ='mittel', meth='funk'))
            && !is.nan(out))
expect_true(is.na(out <- et_hoehe('fi', alter=-10, bon=34.6, bon_typ='abs',
                                  hoehe_typ='ober', meth='funk'))
            && !is.nan(out))

# Ertragsklassen -3 bis 7
expect_true(is.na(out <- et_hoehe('fi', alter=71, bon=-3.5, bon_typ='rel',
                                  hoehe_typ='mittel', meth='funk'))
            && !is.nan(out))
expect_true(is.na(out <- et_hoehe('bu', alter=103, bon=49.1, bon_typ='abs',
                                  hoehe_typ='mittel', meth='funk'))
            && !is.nan(out))
expect_true(is.na(out <- et_hoehe('dgl', alter=13, bon=7.5, bon_typ='rel',
                                  hoehe_typ='ober', meth='funk'))
            && !is.nan(out))
expect_true(is.na(out <- et_hoehe('ki', alter=12, bon=3, bon_typ='abs',
                                  hoehe_typ='ober', meth='funk'))
            && !is.nan(out))



#===============================================================================
#  Testet die klassische Inter-/Extrapolation mittels Dreisatz
#===============================================================================

# Teste Höhen-Ekl-Kombinationen, die bei der Tafelkonstruktion verwendet wurden
# Extrapolationsbereich (Fi: -1, 0, Dgl: 0, Ki: -1 Ekl) nicht getestet, weil
# dort bei klassischer Methode Abweichungen von der Norm (s. test_bontrans()).
norm <- norm[!(norm$Art == 'fi' & norm$Ekl %in% -1:0), ]
norm <- norm[!(norm$Art == 'dgl' & norm$Ekl == 0), ]
norm <- norm[!(norm$Art == 'ki' & norm$Ekl == -1), ]

ekl2h100  <- numeric(nrow(norm))
h1002h100 <- numeric(nrow(norm))

for(i in seq_len(nrow(norm))){
  ekl2h100[i] <- et_hoehe(norm[i, 'Art'], alter=100, bon=norm[i, 'Ekl'],
                          bon_typ='rel', hoehe_typ="ober", meth='klass')
  h1002h100[i] <- et_hoehe(norm[i, 'Art'], alter=100, bon=norm[i, 'H100'],
                           bon_typ='abs', hoehe_typ="ober", meth='klass')
}

expect_equal(norm$H100, ekl2h100)
expect_equal(norm$H100, h1002h100)


# Interpolation
expect_equal(et_hoehe('fi', alter=86, bon=2.3, bon_typ='rel', hoehe_typ='ober', meth='klass'),
             27.5)
expect_equal(et_hoehe('ei', alter=136, bon=0.6, bon_typ='rel', hoehe_typ='mittel', meth='klass'),
             30.8)
expect_equal(et_hoehe('bu', alter=76, bon=30.9, bon_typ='abs', hoehe_typ='ober', meth='klass'),
             26.2)
expect_equal(et_hoehe('ki', alter=81, bon=30.6, bon_typ='abs', hoehe_typ='mittel', meth='klass'),
             26.9)


# Extrapolation
# Bonität
expect_equal(et_hoehe('fi', alter=71, bon=-1.5, bon_typ='rel', hoehe_typ='mittel', meth='klass'),
             39.2)
expect_equal(et_hoehe('bu', alter=103, bon=41.7, bon_typ='abs', hoehe_typ='mittel', meth='klass'),
             40.3)
expect_equal(et_hoehe('ei', alter=133, bon=3.5, bon_typ='rel', hoehe_typ='ober', meth='klass'),
             22.6)
expect_equal(et_hoehe('dgl', alter=87, bon=31.1, bon_typ='abs', hoehe_typ='ober', meth='klass'),
             29.3)
# Alter
expect_equal(et_hoehe('dgl', alter=13, bon=2.4, bon_typ='rel', hoehe_typ='ober', meth='klass'),
             3.9)
expect_equal(et_hoehe('ki', alter=12, bon=25, bon_typ='abs', hoehe_typ='ober', meth='klass'),
             5.7)
expect_equal(et_hoehe('ei', alter=217, bon=1.3, bon_typ='rel', hoehe_typ='mittel', meth='klass'),
             34.0)
expect_equal(et_hoehe('fi', alter=142, bon=34.6, bon_typ='abs', hoehe_typ='mittel', meth='klass'),
             37.9)



# Vektorisiertes
expect_equal(et_hoehe(c('ei', 'bu', 'dgl'), alter=54, bon=1.3, bon_typ='rel',
                      hoehe_typ='ober', meth='klass'),
             c(18.9, 20.0, 31.9))
expect_equal(
  suppressMessages(et_hoehe('fi', alter=seq(100,140,10), bon=34.6, bon_typ='abs',
                      hoehe_typ='mittel', meth='klass')),
  c(33.5, 34.7, 35.7, 36.7, 37.7))
expect_equal(et_hoehe('bu', alter=76, bon=seq(30.9,40,2), bon_typ='abs',
                      hoehe_typ='ober', meth='klass'),
             c(26.2, 28, 29.9, 31.7, 33.6))


# Außerhalb des Alters- & Bonitätsbereiches
# zwischen 5 und max. zulässigem Alter (Ei 220, Bu 180 und Fi, Dgl, Ki 160)
expect_true(is.na(out <- et_hoehe('ei', alter=4, bon=1.3, bon_typ='rel',
                                  hoehe_typ='mittel', meth='klass'))
            && !is.nan(out))
expect_true(is.na(out <- et_hoehe('fi', alter=-1, bon=34.6, bon_typ='abs',
                                  hoehe_typ='mittel', meth='klass'))
            && !is.nan(out))
expect_true(is.na(out <- et_hoehe('ei', alter=225, bon=1.3, bon_typ='rel',
                                  hoehe_typ='mittel', meth='klass'))
            && !is.nan(out))
expect_true(is.na(out <- et_hoehe('fi', alter=180, bon=34.6, bon_typ='abs',
                                  hoehe_typ='mittel', meth='klass'))
            && !is.nan(out))

# Ertragsklassen -2 bis 4
expect_true(is.na(out <- et_hoehe('fi', alter=71, bon=-2.5, bon_typ='rel',
                                  hoehe_typ='mittel', meth='klass'))
            && !is.nan(out))
expect_true(is.na(out <- et_hoehe('bu', alter=103, bon=44.9, bon_typ='abs',
                                  hoehe_typ='mittel', meth='klass'))
            && !is.nan(out))
expect_true(is.na(out <- et_hoehe('dgl', alter=13, bon=4.5, bon_typ='rel',
                                  hoehe_typ='ober', meth='klass'))
            && !is.nan(out))
expect_true(is.na(out <- et_hoehe('ki', alter=12, bon=16.6, bon_typ='abs',
                                  hoehe_typ='ober', meth='klass'))
            && !is.nan(out))

#===============================================================================
#
#  Teste Bonitätsumrechnung mit et_bontrans()
#
#===============================================================================
#  Sowohl funktionale als auch klassische Methode.


norm <-data.frame(
  Art = rep(c("ei", "bu", "fi", "dgl", "ki"), times=c(5, 5, 5, 4, 5)),
  H100 = c(33, 30, 27, 24, 21, 40.5, 36.5, 32.5, 28.5, 24.5, 43, 39, 35, 31, 27,
           50, 45, 40, 35, 37, 33, 29, 25, 21),
  Ekl = c(-1, 0, 1, 2, 3, -1, 0, 1, 2, 3, -1, 0, 1, 2, 3, 0, 1, 2, 3, -1, 0, 1, 2, 3))


#===============================================================================
#  Testet die Eingabe Validierung
#===============================================================================
expect_silent(et_bontrans("Ei", bon=32))
expect_error(et_bontrans("Ei",  bon="0"))
expect_error(et_bontrans("Ei",  bon="a"))
expect_error(et_bontrans("Ei",  bon=TRUE))

# Baumartencode als character übergeben
expect_equal(et_bontrans("211", bon=32), 1.1)


#===============================================================================
#  Testet die funktionalisierte Inter-/Extrapolation
#===============================================================================
res <- data.frame(Art=character(nrow(norm)), H100=numeric(nrow(norm)),  Ekl=numeric(nrow(norm)))

# Treffer  Ekl <-> SI
for(i in seq_len(nrow(norm))){
  res[i, 'Art']  <- norm[i, 'Art']
  res[i, 'Ekl']  <- et_bontrans(art=norm[i, 'Art'], bon=norm[i, 'H100'],
                                richtung="abs_zu_rel", meth="funk")
  res[i, 'H100'] <- et_bontrans(art=norm[i, 'Art'], bon=norm[i, 'Ekl'],
                                richtung="rel_zu_abs", meth="funk")
}
expect_equivalent(norm, res)


# Interpolation
expect_equal(et_bontrans('ei', bon=-0.7, richtung="rel_zu_abs", meth="funk"), 32.1)
expect_equal(et_bontrans('ei', bon=32.1, richtung="abs_zu_rel", meth="funk"), -0.7)

expect_equal(et_bontrans('ki', bon=2.4, richtung="rel_zu_abs", meth="funk"), 23.4)
expect_equal(et_bontrans('ki', bon=23.4, richtung="abs_zu_rel", meth="funk"), 2.4)


# Extrapolation
expect_equal(et_bontrans('fi', bon=-1.7, richtung="rel_zu_abs", meth="funk"), 45.8)
expect_equal(et_bontrans('fi', bon=48.5, richtung="abs_zu_rel", meth="funk"), -2.4)

expect_equal(et_bontrans('bu', bon=2.7, richtung="rel_zu_abs", meth="funk"), 25.7)
expect_equal(et_bontrans('bu', bon=25.7, richtung="abs_zu_rel", meth="funk"), 2.7)


# Vektorisiertes
expect_equal(et_bontrans('ki', bon=c(0.3, 1.1,2.4), richtung="rel_zu_abs", meth="funk"),
             c(31.8, 28.6, 23.4))
expect_equal(et_bontrans(c('bu', 'ki', 'fi'), bon=2.4, richtung="rel_zu_abs", meth="funk"),
             c(26.9, 23.4, 29.4))
expect_equal(et_bontrans(c('bu', 'ki', 'fi'), bon=c(0.1, 1.2, 2.3), richtung="rel_zu_abs", meth="funk"),
             c(36.1, 28.2, 29.8))

expect_equal(et_bontrans('ki', bon=c(23.4, 25.1, 27.0), richtung="abs_zu_rel", meth="funk"),
             c(2.4, 2, 1.5))
expect_equal(et_bontrans(c('ei', 'ki', 'dgl'), bon=26.6, richtung="abs_zu_rel", meth="funk"),
             c(1.1, 1.6, 4.7))
expect_equal(et_bontrans(c('ei', 'ki', 'dgl'), bon=c(26.6, 28.2, 35.6), richtung="abs_zu_rel", meth="funk"),
             c(1.1, 1.2, 2.9))


# Außerhalb des Bonitätsbereiches
expect_true(is.na(et_bontrans('dgl', bon=-3.3, richtung="rel_zu_abs", meth="funk")))
expect_true(is.na(et_bontrans('dgl', bon=75, richtung="abs_zu_rel", meth="funk")))




#===============================================================================
#  Testet die klassische Inter-/Extrapolation mittels Dreisatz
#===============================================================================

# Treffer  Ekl <-> SI

# Die tabellierten Werte der Ertragstafel enden für das Nadelholz in den guten
# Ertragsklassen schon vor dem Alter 100. Das führt dazu, dass auch die Werte
# für die Bonitätsumrechnung extrapolierte werden müssen. Die klassische Methode
# der Extrapolation mittels Dreisatz zeigt hier zum Teil leider Abweichungen von
# den bei der Konstruktion der Tafeln vorgegebenen Zusammenhänge von H100 und
# Ekl.
# Dies wird besonders sichtbar bei der Umwandlung rel_zu_abs, da dort nach
# Rundung auf eine Nachkommastelle durch Werte im Zehnerbereich (Ekl liegt im
# Einerbereich) ein Stelle mehr zur Verfügung steht.
# Deswegen wird der Extrapolationsbereich (Fi: -1, 0, Dgl: 0, Ki: -1 Ekl) nicht
# getestet.

norm <- norm[!(norm$Art == 'fi' & norm$Ekl %in% -1:0), ]
norm <- norm[!(norm$Art == 'dgl' & norm$Ekl == 0), ]
norm <- norm[!(norm$Art == 'ki' & norm$Ekl == -1), ]

res <- data.frame(Art=character(nrow(norm)), H100=numeric(nrow(norm)),  Ekl=numeric(nrow(norm)))

for(i in seq_len(nrow(norm))){
  res[i, 'Art']  <- norm[i, 'Art']
  res[i, 'Ekl']  <- et_bontrans(art=norm[i, 'Art'], bon=norm[i, 'H100'],
                                richtung="abs_zu_rel", meth="klass")
  res[i, 'H100'] <- et_bontrans(art=norm[i, 'Art'], bon=norm[i, 'Ekl'],
                                richtung="rel_zu_abs", meth="klass")
}
expect_equivalent(norm, res)


# Interpolation
expect_equal(et_bontrans('ei', bon=-0.7, richtung="rel_zu_abs", meth="klass"), 32.1)
expect_equal(et_bontrans('ei', bon=32.1, richtung="abs_zu_rel", meth="klass"), -0.7)

expect_equal(et_bontrans('ki', bon=2.4, richtung="rel_zu_abs", meth="klass"), 23.4)
expect_equal(et_bontrans('ki', bon=23.4, richtung="abs_zu_rel", meth="klass"), 2.4)


# Extrapolation
expect_equal(et_bontrans('fi', bon=-1.7, richtung="rel_zu_abs", meth="klass"), 48.5)
expect_equal(et_bontrans('fi', bon=48.5, richtung="abs_zu_rel", meth="klass"), -1.7)

expect_equal(et_bontrans('bu', bon=2.7, richtung="rel_zu_abs", meth="klass"), 25.7)
expect_equal(et_bontrans('bu', bon=25.7, richtung="abs_zu_rel", meth="klass"), 2.7)


# Vektorisiertes
expect_equal(et_bontrans('ki', bon=c(0.3, 1.1,2.4), richtung="rel_zu_abs", meth="klass"),
             c(31.8, 28.6, 23.4))
expect_equal(et_bontrans(c('bu', 'ki', 'fi'), bon=2.4, richtung="rel_zu_abs", meth="klass"),
             c(26.9, 23.4, 29.4))
expect_equal(et_bontrans(c('bu', 'ki', 'fi'), bon=c(0.1, 1.2, 2.3), richtung="rel_zu_abs", meth="klass"),
             c(36.1, 28.2, 29.8))

expect_equal(et_bontrans('ki', bon=c(23.4, 25.1, 27.0), richtung="abs_zu_rel", meth="klass"),
             c(2.4, 2, 1.5))
expect_equal(et_bontrans(c('ei', 'ki', 'dgl'), bon=26.6, richtung="abs_zu_rel", meth="klass"),
             c(1.1, 1.6, NA))
expect_equal(et_bontrans(c('ei', 'ki', 'dgl'), bon=c(26.6, 28.2, 35.6), richtung="abs_zu_rel", meth="klass"),
             c(1.1, 1.2, 2.9))


# Außerhalb des Bonitätsbereiches
expect_true(is.na(et_bontrans('dgl', bon=-2.7, richtung="rel_zu_abs", meth="klass")))
expect_true(is.na(et_bontrans('dgl', bon=65, richtung="abs_zu_rel", meth="klass")))

#===============================================================================
#
#  Teste Bonitierung mit et_bonitaet()
#
#===============================================================================
#  Sowohl funktionale als auch klassische Methode.
#
#  Unterstützung bei der Konstruktion von Testfällen bieten die Bonitätsfächer
#  aus data-raw/bonitaetsfaecher_fuer_tests.R


#===============================================================================
#  Testet die Eingabe Validierung
#===============================================================================
expect_error(et_bonitaet()) # verpflichtend art, alter, hoehe
expect_error(et_bonitaet('fi'))
expect_error(et_bonitaet('fi', alter=50))
expect_error(et_bonitaet('fi', hoehe=25))
expect_error(et_bonitaet(art='fi', alter=50, hoehe=25, hoehe_typ="spitz"))
expect_error(et_bonitaet(art='fi', alter=50, hoehe=25, methode="modern"))
expect_error(et_bonitaet(art='fi', alter=50, hoehe=25, bon_typ="si"))

expect_silent(et_bonitaet(211, alter=80, hoehe=35))
expect_error(et_bonitaet(211, alter="80", hoehe=35))
expect_error(et_bonitaet(211, alter=80, hoehe="35"))
expect_error(et_bonitaet(211, alter=80, hoehe=TRUE))

expect_silent(et_bonitaet(211, alter=80, hoehe=35, kapp_na=TRUE))
expect_error(et_bonitaet(211, alter=80, hoehe=35, kapp_na=NULL))
expect_error(et_bonitaet(211, alter=80, hoehe=35, kapp_na=NA))
expect_error(et_bonitaet(211, alter=80, hoehe=35, kapp_na=1))
expect_error(et_bonitaet(211, alter=80, hoehe=35, kapp_na="a"))
expect_error(et_bonitaet(211, alter=80, hoehe=35, kapp_na=c(TRUE, TRUE, FALSE)))

# Baumartencode als character übergeben
expect_equal(et_bonitaet("111", alter=40, hoehe=20), -0.4)

# Alter als Fließkommazahl
expect_error(et_bonitaet(111, alter=40.4, hoehe=20))


#===============================================================================
#  Testet die funktionalisierte Inter-/Extrapolation (funk_bonitieren)
#===============================================================================

# Im Bereich der Ertragstafel
# ------------------------------------------------------------------------------
# Treffer der Oberhöhen
expect_equal(et_bonitaet(211, hoehe=40.5, alter=100, hoehe_typ="ober"), -1, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=26.1, alter=70, hoehe_typ="ober"), 1, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=29.0, alter=140, hoehe_typ="ober"), 3, tol=0.01)

# Treffer der Mittelhöhen (+/- ein Zentimeter)
expect_equal(et_bonitaet(211, hoehe=38.5, hoehe_typ="m", alter=100), -1, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=23.9, hoehe_typ="m", alter=70), 1, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=27.9, hoehe_typ="m", alter=140), 3, tol=0.01)

# Interpolation
expect_equal(et_bonitaet(211, hoehe=24, hoehe_typ="m", alter=50), -1.3, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=27, hoehe_typ="m", alter=80), 0.9, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=28, hoehe_typ="m", alter=120), 2.5, tol=0.01)


# Extrapolation der Ertragsklasse
# ------------------------------------------------------------------------------
expect_equal(et_bonitaet(211, hoehe=29, hoehe_typ="m", alter=50), -2.8, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=41, hoehe_typ="m", alter=90), -2.2, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=43, hoehe_typ="m", alter=110), -1.7, tol=0.01)

expect_equal(et_bonitaet(211, hoehe=15, hoehe_typ="m", alter=140), 6.3, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=18, hoehe_typ="m", alter=100), 4.3, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=12, hoehe_typ="m", alter=60), 3.6, tol=0.01)


# Extrapolation in Richtung junger Alter
# ------------------------------------------------------------------------------
# Ekl -1 beginnt bei 25

# ohne Hossfeld
expect_equal(et_bonitaet(211, hoehe=4.5, hoehe_typ="ober", alter=20),
             1.3, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=2, hoehe_typ="ober", alter=10),
             -1.1, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=0.1, hoehe_typ="ober", alter=5),
             -0.3, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=0.01, hoehe_typ="ober", alter=3),
             -1.1, tol=0.01)

# mit Hossfeld
expect_equal(et_bonitaet(211, hoehe=5, hoehe_typ="ober", alter=20, hoss=TRUE),
             1.5, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=2, hoehe_typ="ober", alter=10, hoss=TRUE),
             0.9, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=0.1, hoehe_typ="ober", alter=5, hoss=TRUE),
             4.4, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=0.01, hoehe_typ="ober", alter=3, hoss=TRUE),
             6.1, tol=0.01)


# Extrapolation in Richtung hoher Alter
# ------------------------------------------------------------------------------
# Ekl 3 endet bei 150
expect_equal(et_bonitaet(211, hoehe=42, hoehe_typ="m", alter=150), -0.1, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=48, hoehe_typ="m", alter=160), -1.2, tol=0.01)
expect_equal(et_bonitaet(211, hoehe=38, hoehe_typ="m", alter=180), 1.4, tol=0.01)


# Absolute Bonitäten
# ------------------------------------------------------------------------------
# Das ist nur eine nachträgliche Umrechnung der relativen Ertragsklassen
# in Oberhöhen im Alter 100
expect_equal(et_bonitaet(211, 70, 26.1, "ober","abs"), 32.5, tol=0.01)
expect_equal(et_bonitaet(211, 42, 14.4, "ober","abs"), 30.1, tol=0.01)
expect_equal(et_bonitaet(211, 15, 6, "ober","abs"), 42.4, tol=0.01)


# Fehler und Kappung
# ------------------------------------------------------------------------------
# Eingabetests
# Vektoren unterschiedlich lang
expect_error(et_bonitaet("fi", c(80, 100), c(39, 35, 31)))
expect_error(et_bonitaet(c("fi", "bu"), 100, c(39, 35, 31)))
expect_error(et_bonitaet(c("fi", "bu"), 100:103, 35))

# negative Alter
expect_true(is.na(et_bonitaet(211, hoehe=30, hoehe_typ="m", alter=-5)))
expect_true(is.na(et_bonitaet(211, hoehe=30, hoehe_typ="o", alter=-5)))
expect_true(is.na(et_bonitaet(211, hoehe=30, hoehe_typ="m", bon_typ='rel', alter=-5)))
expect_true(is.na(et_bonitaet(211, hoehe=30, hoehe_typ="o", bon_typ='rel', alter=-5)))

# negative Höhen
et_bonitaet(211, hoehe=-3, hoehe_typ="m", alter=180)

# unbekannte Baumart
expect_error(et_bonitaet(art="xyz", 100, 35))

# Kappungen
expect_warning(bons <- et_bonitaet("fi", 100, c(55, 39, 35, 31, 27, 8),
                                   hoehe_typ="m", methode="funk", kapp_na=TRUE))
expect_equal(bons, c(NA, -0.3, 0.7, 1.7, 2.8, NA), tol=0.01)

expect_warning(bons <- et_bonitaet("fi", 100, c(55, 39, 35, 31, 27, 8),
                                   hoehe_typ="m", methode="funk", kapp_na=FALSE))
expect_equal(bons, c(-3.0, -0.3, 0.7, 1.7, 2.8, 7.0), tol=0.01)

expect_warning(bons <- et_bonitaet("fi", 100, c(55, 39, 35, 31, 27, 8),
                                   hoehe_typ="m", meth="funk", bon_typ="abs", kapp_na=TRUE))
expect_equal(bons, c(NA, 40.1, 36.1, 32.0, 28.0, NA), tol=0.01)



#===============================================================================
#  Testet die klassische Inter-/Extrapolation mittels Dreisatz (klas_bonitieren)
#===============================================================================

# Klare Interpolation des Alters
# ==============================================================================
# klassische, einfache Fälle
# in der Altersspanne 45-115 sind alle Ekl vorhanden

# Alters- & Höhentreffer [Abkürzung]
expect_equal(et_bonitaet(211, 70, 26.1, "ober","relativ","klass"), 1, tol=0.01)
# Toleranztest Höhe
expect_equal(et_bonitaet(211, 70, 26.099, "ober","relativ","klass"), 1, tol=0.01)
# Alterstreffer [Abkürzung]
expect_equal(et_bonitaet(211, 55, 24.8, "ober","relativ","klass"), 0, tol=0.01)
# Altersinterpolation
expect_equal(et_bonitaet(211, 51, 24, "ober","relativ","klass"), -0.2, tol=0.01)
expect_equal(et_bonitaet(211, 103, 23, "ober","relativ","klass"), 3.5, tol=0.01)

# Alter für benötigte Ekl können interpoliert werden,
# Andere nicht-relevante Ekl müssten extrapoliert werden.
# Sollte nicht stattfinden, weil vorher in Code abgefangen. Nur im Debugging sichtbar.
# Alterstreffer
expect_equal(et_bonitaet(211, 40, 15, "ober","relativ","klass"), 1.1, tol=0.01)
expect_equal(et_bonitaet(211, 140, 37, "ober","relativ","klass"), 1.2, tol=0.01)
# Interpolation
expect_equal(et_bonitaet(211, 42, 14.4, "ober","relativ","klass"), 1.6, tol=0.01)
expect_equal(et_bonitaet(211, 133, 35.2, "ober","relativ","klass"), 1.4, tol=0.01)


# Extrapolation des Alters
# ==============================================================================

# Extrapolation nach unten
# ------------------------------------------------------------------------------
# mind. eine Alter für benötigte Ekl muss extrapoliert werden
# Alterstreffer & Extrapolation
expect_equal(et_bonitaet(211, 30, 12.5, "ober","relativ","klass"), 0.2, tol=0.01)
# Interpolation & Extrapolation
expect_equal(et_bonitaet(211, 33, 14.2, "ober","relativ","klass"), 0.1, tol=1e-1)
expect_equal(et_bonitaet(211, 42, 11.4, "ober","relativ","klass"), 2.6, tol=0.01)
# Alter aller Ekl müssen extrapoliert werden (< 25a)
expect_equal(et_bonitaet(211, 15, 6, "ober","relativ","klass"), -1.2, tol=0.01)
expect_equal(et_bonitaet(211, 32, 8, "ober","relativ","klass"), 2.4, tol=0.01)

# Extrapolation nach oben
# ------------------------------------------------------------------------------
# mind. eine Alter für benötigte Ekl muss extrapoliert werden (>115)
# Alterstreffer & Extrapolation
expect_equal(et_bonitaet(211, 140, 40, "ober","relativ","klass"), 0.5, tol=0.01)
# Interpolation & Extrapolation
expect_equal(et_bonitaet(211, 131, 39, "ober","relativ","klass"), 0.5, tol=0.01)
expect_equal(et_bonitaet(211, 147, 36.5, "ober","relativ","klass"), 1.4, tol=0.01)
# Alter aller Ekl müssen extrapoliert werden (>150) unterhalb Alterskappung (<180)
expect_equal(et_bonitaet(211, 154, 32, "ober","relativ","klass"), 2.5, tol=0.01)
expect_equal(et_bonitaet(211, 162, 44, "ober","relativ","klass"), 0.3, tol=0.01)

# Absolute Bonitäten
# ------------------------------------------------------------------------------
# Das ist nur eine nachträgliche Umrechnung der relativen Ertragsklassen
# in Oberhöhen im Alter 100
expect_equal(et_bonitaet(211, 70, 26.1, "ober","abs","klass"), 32.5, tol=0.01)
expect_equal(et_bonitaet(211, 42, 14.4, "ober","abs","klass"), 30.2, tol=0.01)
expect_equal(et_bonitaet(211, 15, 6, "ober","abs","klass"), 41.1, tol=0.01)


# Fehler und Kappung
# ------------------------------------------------------------------------------
# Eingabetests

# Alter außerhalb des Altersintervalls (Bu: 5-180)
expect_warning(bon <- et_bonitaet('bu', hoehe=10, hoehe_typ="m", alter=3, meth="klass"))
expect_true(is.na(bon))
expect_warning(bon <- et_bonitaet(211, 190, 50, "ober","relativ","klass"))
expect_true(is.na(bon))

# Ekl Kappung
expect_warning(bons <- et_bonitaet("fi", 100, c(55, 39, 35, 31, 27, 8),
                                   hoehe_typ="m", meth="klass", kapp_na=TRUE))
expect_equal(bons, c(NA, -0.2, 0.7, 1.7, 2.8, NA), tol=0.01)

expect_warning(bons <- et_bonitaet("fi", 100, c(55, 39, 35, 31, 27, 8),
                                   hoehe_typ="m",meth="klass", kapp_na=FALSE))
expect_equal(bons, c(-2.0, -0.2, 0.7, 1.7, 2.8, 4.0), tol=0.01)

expect_warning(bons <- et_bonitaet("fi", 100, c(55, 39, 35, 31, 27, 8),
                                   hoehe_typ="m",meth="klass", bon_typ="abs", kapp_na=TRUE))
expect_equal(bons, c(NA, 40.1, 36.1, 32.0, 28.0, NA), tol=0.01)

---
title: "Beispiele"
author: "M. Albert"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Beispiele}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup, echo=FALSE}
library(et.nwfva)
```


## Bonitieren

Die Bonitierung eines Bestandes erfolgt in den neuen Ertragstafeln für Eiche, Buche, Fichte, Douglasie und Kiefer (Albert et al., 2021) gemäß der klassischen Einordnungsbeziehung über das Wertepaar Bestandesalter und Bestandeshöhe (Ober- oder Mittelhöhe. Den neuen Ertragstafeln liegen baumartspezifische funktionalisierte Bonitätsfächer basierend auf den Alters-Oberhöhenverläufen der Tafeln aus der Ertragstafelsammlung von Schober (1995) zu Grunde.

```{r et_bonitaet}
# Bonitätsschätzung: Ausgabe der relativen Ertragsklasse
et_bonitaet(art="Buche", alter=70, hoehe=29.1, hoehe_typ="ober")
```

```{r et_bontrans}
# Umrechnung von rel. Ertragsklasse in abs. Oberhöhenbonität
et_bontrans("bu", bon=0.18, richtung="rel_zu_abs")
```


## Inter-/Extrapolation von Ertragstafelwerten

Eine lineare Interpolation der Ertragstafelwerte zwischen den Altern und Bonitäten ist eine praktikable und praxisnahe Lösung. Soweit im Paket Funktionen hinterlegt sind (z. B. Oberhöhe), wird ein exakter Wert berechnet.
Eine lineare Extrapolation über den Alters- bzw. Bonitätsrahmen der Ertragstafeln hinaus ist streng genommen nicht zulässig. Die erzeugten Ertragstafelwerte sind kritisch zu hinterfragen. Funktional erzeugte Werte im Extrapolationsbereich sind in gewissen Maße vertrauenswürdiger.

Hier eine beispielhafte Interpolation zwischen den Altersstufen und Bonitäten der Douglasien-Ertragstafel:
``` {r tafel-Interpolation}
et_tafel(art="Dgl", alter=37, bon=0.3)
```

Hier eine beispielhafte Extrapolation über den Altersrahmen der I. Ekl der Douglasien-Tafel hinaus (Werte kritisch interpretieren!):

```{r tafel_extrapolation}
et_tafel(art="Dgl", alter=140, bon=1.0)
```


## Eine beispielhafte Grafik

Eine grafische Analyse des Altersverlaufes verschiedener Ertragstafelwerte kann z. B. Bonitätsunterschiede verdeutlichen.  

```{r Beispiel_Abbildung, fig.width=7, fig.height=5}

# Beispielhafte Abbildung des Zuwachses über dem Alter 
# laut Buchen-Ertragstafel für die -I. bis III. Ekl.

bu <- et_tafel(art="Bu")

plot(0, 0, type='n', xlim=c(20, 150),ylim=c(0, 20),
     xlab="Alter [a]", ylab="iV [m³/ha/a]")

grid(nx=NULL, ny=NULL, col="lightgray", lty="dotted")

lines(iV ~ Alter, data=bu[bu$Ekl == -1, ], col="black", lwd=2)
lines(iV ~ Alter, data=bu[bu$Ekl == 0, ], col="tan4",  lwd=2)
lines(iV ~ Alter, data=bu[bu$Ekl == 1, ], col="tan3",  lwd=2)
lines(iV ~ Alter, data=bu[bu$Ekl == 2, ], col="tan2",  lwd=2)
lines(iV ~ Alter, data=bu[bu$Ekl == 3, ], col="tan1",  lwd=2)

legend("bottomright", inset=0.01, box.lty=0,
       legend=c("-1. Ekl","0. Ekl", "1. Ekl", "2. Ekl","3. Ekl"),
       col=c("black","tan4", "tan3", "tan2", "tan1"), 
       lty=1, lwd=2, cex=0.8)
```


## Literatur
Albert M., Nagel J., Schmidt M., Nagel R.-V., Spellmann H. (2021): Eine neue Generation von Ertragstafeln für Eiche, Buche, Fichte, Douglasie und Kiefer [Datensatz]. Version 1.0. Zenodo. https://doi.org/10.5281/zenodo.6343906

Schober, R. (1995): Ertragstafeln wichtiger Baumarten. 4. Aufl. Frankfurt am Main: J. D. Sauerländer‘s Verlag.

---
title: "Nutzerhinweise zum Geleit"
subtitle: "Eine neue Generation von Ertragstafeln für die Baumarten Eiche, Buche, Fichte, Douglasie und Kiefer"
author: "M. Albert, J. Nagel, M. Schmidt, R.-V. Nagel und H. Spellmann"
date: "Dezember 2021 (aktualisiert am 01.04.2022)"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Nutzerhinweise zum Geleit}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

**Die wichtigsten Informationen in Kürze vorab:**

Die neuen Ertragstafeln

* bilden das aktuelle Zuwachsniveau ab
* beschreiben ein mittleres Ertragsniveau
* unterstellen einen in der Jugend modifizierten Bonitätsfächer auf Basis der baumartenspezifischen Alters-Oberhöhen-Beziehungen der Ertragstafelsammlung von Schober (1995)
* unterstellen eine gestaffelte Hochdurchforstung als waldbauliche Norm
* beziehen sich nur auf den Oberstand (Gesamtheit aller Bäume, deren Höhe > 50 % der Bestandesoberhöhe (h100) ist)
* geben eine Grundflächenhaltung vor, die den Bestockungsgrad von 1,0 definiert
* sollten nur für Planungszeiträume bis 20 Jahre angewendet werden
* haben einen räumlichen Gültigkeitsbereich für Nordwestdeutschland
* sehen eine periodische, in Zeitintervallen von ca. 10 bis 20 Jahren durchzuführende Neuparametrisierung der Zuwachsfunktionen und eine Überarbeitung der Ertragstafelwerte vor


## 1. Einführung
Die klassischen Ertragstafeln bieten der Forstwirtschaft seit langer Zeit Orientierung und Norm bei der Planung, Bewirtschaftung und Bewertung der Wälder. 
Seit den ersten Ertragstafeln, die eher örtliche Erfahrungstabellen waren (Paulsen 1795), wurde die Methodik der Herleitung der Tafelwerke immer wieder angepasst, der ursprüngliche Aufbau blieb jedoch weitgehend unverändert. 
Die erste Ertragstafelgeneration basierte auf einer geringen Datengrundlage und hatte eine recht beschränkte regionale Gültigkeit. 
Die zweite Ertragstafelgeneration erfuhr durch Ganghofer (1881) eine Vereinheitlichung der Datengrundlage und Konstruktionsmethodik mit einer Bindung an „normale“ Bestände. 
Prominente Beispiele für diese Großgebietsertragstafeln stammen von Schwappach (1902) sowie deren Weiterentwicklungen durch Wiedemann (1949) und Schober (1975). 
Die dritte Generation der Ertragstafeln, beginnend mit den Arbeiten von Gehrhardt (1923) und Assmann und Franz (1963), verwendet biometrisch-statistische Modelle, um aus Versuchsflächenbeobachtungen die Ertragstafelverläufe der Bestandesgrößen abzuleiten. 
Auch viele neuere Ertragstafeln folgen dieser Methodik (vgl. z. B. Dittmar et al. 1983, Wenk et al. 1984, Bergel 1985, Nagel 1985, Böckmann 1990, Lockow 2003, Röhe et al. 2019).

Die Herleitung der neuen, vierten Generation von Ertragstafeln für die fünf Hauptbaumarten Eiche (*Quercus petraea* [Mattuschka] Liebl. resp. *Quercus robur* L.), Buche (*Fagus sylvatica* L.), Fichte (*Picea abies* [L.] Karst), Douglasie (*Pseudotsuga menziesii* [Mirb.] Franco) und Kiefer (*Pinus silvestris* L.) geht über das Prinzip eines biometrisch-statistischen Ausgleichs von empirischen Beobachtungen hinaus.
Aufbauend auf realen Versuchsflächendaten werden künstliche Modellbestände generiert und mit dem Einzelbaumwachstumssimulator TreeGrOSS der NW-FVA (Hansen und Nagel 2014, Sprauer und Nagel 2018) für 30-Jahre fortgeschrieben.
Diese Simulationsdaten werden anschließend mittels eines Systems von biometrisch-statistischen Funktionsgleichungen in Tafelwerke überführt.
Dieses Vorgehen hat zwei entscheidende Vorteile.
Zum einen wird das Wachstum mit den Zuwachsfunktionen von TreeGrOSS auf dem aktuell herrschenden Zuwachsniveau projiziert, was aufgrund der sich ändernden Standortverhältnisse bei langfristigen Versuchsflächen für weit zurückliegende Aufnahmen nicht gegeben wäre.
Zweitens kann im Waldwachstumssimulator die von der NW-FVA empfohlene waldbauliche Behandlung einer gestaffelten Hochdurchforstung abgebildet werden, während die empirische Datenbasis für diese waldbauliche Vorgehensweise für eine Ertragstafelerstellung zu gering ist.

Eine periodische, in Zeitintervallen von ca. 10 bis 20 Jahren durchzuführende Neuparametrisierung der modellbasierten Ertragstafeln ist vorgesehen, um den weiter fortschreitenden Veränderungen der Standort-Leistungsbeziehungen vor allem aufgrund des Klimawandels sowie waldbaulichen und methodischen Weiterentwicklungen Rechnung zu tragen.


## 2.	Erläuterung zur Ertragstafelsammlung
Die Erstellung der Ertragstafeln basiert auf zwei grundlegenden Festlegungen: (1) es wird ein mittleres Ertragsniveau abgebildet und (2) es wird ein in der Jugend modifizierter, funktionalisierter Bonitätsfächer auf Basis der baumartenspezifischen Alters-Oberhöhen-Beziehungen der Ertragstafelsammlung von Schober (1995) angewendet.


### 2.1	Datengrundlage und Gültigkeitsbereich
Die Datengrundlage stammt von ertragskundlichen Versuchsflächen der NW-FVA. 
Es wurden Versuchsparzellen verwendet, die konsequent hochdurchforstet wurden und somit der abzubildenden waldbaulichen Norm einer gestaffelten Hochdurchforstung möglichst nahe kommen. 
Ziel war es dabei, ein möglichst breites Alters- und Bonitätsspektrum abzubilden. 
Anhand dieser Versuchsflächendaten wurden die mit dem Einzelbaumwachstumssimulator fortzuschreibenden Modellbestände generiert. 
Die entsprechenden Kennwerte der Modellbestände für die fünf Hauptbaumarten sind in der folgenden Tabelle aufgelistet.


```{r tabelle1_html, echo=FALSE, results="asis"}
cat('
<table class="table" style="margin-left: auto; margin-right: auto;">
<caption>Datengrundlage für die Ertragstafelerstellung für die fünf Hauptbaumarten: Anzahl der generierten Modellbestände mit ihren Alters- und Oberhöhenbonitätskennwerten. Die Anzahl ergibt
sich aus der in Klammern angegebenen Anzahl von Versuchsparzellen multipliziert mit den verwendeten Aufnahmen abzüglich ausgesonderter Startkonstellationen.</caption>
 <thead>
<tr>
<th style="empty-cells: hide;border-bottom:hidden;" colspan="1"></th>
<th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="1"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Anzahl</div></th>
<th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="3"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Alter zu Beginn der Projektion</div></th>
<th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="3"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Oberhöhenbonität h<sub>100</sub></div></th>
</tr>
  <tr>
   <th style="text-align:left;">   </th>
   <th style="text-align:center;"> Modellbestände </th>
   <th style="text-align:center;"> Min. </th>
   <th style="text-align:center;"> Mittelwert </th>
   <th style="text-align:center;"> Max. </th>
   <th style="text-align:center;"> 5% Quantil </th>
   <th style="text-align:center;"> Mittelwert </th>
   <th style="text-align:center;"> 95% Quantil </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:left;font-weight: bold;"> Eiche </td>
   <td style="text-align:center;"> 463 (101) </td>
   <td style="text-align:center;"> 17 </td>
   <td style="text-align:center;"> 74 </td>
   <td style="text-align:center;"> 170 </td>
   <td style="text-align:center;"> 19.4 </td>
   <td style="text-align:center;"> 27.3 </td>
   <td style="text-align:center;"> 36.4 </td>
  </tr>
  <tr>
   <td style="text-align:left;font-weight: bold;"> Buche </td>
   <td style="text-align:center;"> 241 (61) </td>
   <td style="text-align:center;"> 25 </td>
   <td style="text-align:center;"> 63 </td>
   <td style="text-align:center;"> 110 </td>
   <td style="text-align:center;"> 26.7 </td>
   <td style="text-align:center;"> 33.1 </td>
   <td style="text-align:center;"> 40.4 </td>
  </tr>
  <tr>
   <td style="text-align:left;font-weight: bold;"> Fichte </td>
   <td style="text-align:center;"> 278 (61) </td>
   <td style="text-align:center;"> 19 </td>
   <td style="text-align:center;"> 42 </td>
   <td style="text-align:center;"> 99 </td>
   <td style="text-align:center;"> 30.1 </td>
   <td style="text-align:center;"> 37.9 </td>
   <td style="text-align:center;"> 42.2 </td>
  </tr>
  <tr>
   <td style="text-align:left;font-weight: bold;"> Douglasie </td>
   <td style="text-align:center;"> 478 (290) </td>
   <td style="text-align:center;"> 15 </td>
   <td style="text-align:center;"> 40 </td>
   <td style="text-align:center;"> 77 </td>
   <td style="text-align:center;"> 35.1 </td>
   <td style="text-align:center;"> 41.7 </td>
   <td style="text-align:center;"> 47.8 </td>
  </tr>
  <tr>
   <td style="text-align:left;font-weight: bold;"> Kiefer </td>
   <td style="text-align:center;"> 142 (32) </td>
   <td style="text-align:center;"> 16 </td>
   <td style="text-align:center;"> 43 </td>
   <td style="text-align:center;"> 96 </td>
   <td style="text-align:center;"> 24.9 </td>
   <td style="text-align:center;"> 30.6 </td>
   <td style="text-align:center;"> 35.7 </td>
  </tr>
</tbody>
</table>
')
```


Der Altersbereich der Modellbestände deckt, insbesondere nach einer 30-jährigen Fortschreibung, den Gültigkeitsbereich der zu erstellenden Ertragstafeln gut ab, nämlich vom Beginn der Durchforstungseingriffe bis zur einsetzenden End-/Zielstärkennutzung.
Das Bonitätsspektrum der verwendeten Versuchsflächen reicht (gerundet) bei Eiche von der -I. bis zur III., bei Buche von der –I. bis zur II,5, bei Fichte von der –I. bis zur II., bei Kiefer von der 0,5 bis zur II. und bei Douglasie von der -I. bis zur III. Ertragsklasse.
Zur Validierung der Ergebnisse wurde auf eine weitaus größere Zahl Versuchsflächen zurückgegriffen.

Die herangezogenen Versuchsflächen stammen weit überwiegend aus dem heutigen Zuständigkeitsbereich der NW-FVA in den Bundesländern Niedersachsen, Hessen, Sachsen-Anhalt und Schleswig-Holstein sowie aus den Bundesländern Nordrhein-Westfalen, Rheinland-Pfalz und dem Saarland, in denen die Niedersächsische Forstliche Versuchsanstalt (NFV) auf ausgewählten Versuchsflächen früher zuständig war und die noch heute in Beobachtung der NW-FVA stehen.
Die neuen Ertragstafeln haben somit einen räumlichen Gültigkeitsbereich für Nordwestdeutschland.
Es handelt sich also um Großgebietstafeln.


### 2.2 Waldbauliches Behandlungskonzept
Das in den Ertragstafeln abgebildete Behandlungskonzept zielt darauf ab, stabile, vertikal und horizontal strukturierte Bestände guter Qualität zu erziehen, die eine möglichst risikoarme Entwicklung der Volumen- und Werterzeugung gewährleisten und Handlungsspielräume für die Verjüngungsphase schaffen (vgl. dazu Waldbaumerkblätter, NW-FVA 2021).
Dazu wird das von der NW-FVA empfohlene Konzept einer gestaffelten Hochdurchforstung umgesetzt, welches bei den ersten Eingriffen starke Durchforstungen im Herrschenden zur konsequenten Förderung einer baumartenspezifisch bemessenen Anzahl von Z-Bäumen, danach einen Übergang zu mäßigen, die Z-Bäume pflegenden und den Bestandesschluss erhaltenden Eingriffen vorsieht und schließlich mit Einsetzen der End-/Zielstärkennutzung ausläuft.
Die Phase der End-/Zielstärkennutzung selbst ist in den Tafeln nicht abgebildet.

Maßgebliches Kriterium für die Durchforstungsstärke ist die in bestimmten Altern bzw. bei bestimmten Oberhöhen anzustrebende Grundflächenhaltung im Oberstand.
Der Unterstand, definiert im Anhalt an Assmann (1961) als die Bäume, deren Höhe ≤ 50 % der Oberhöhe (H100) des Bestandes in gegebenem Alter ist, wird nicht bei der Bemessung der Eingriffsstärken und auch nicht in den Grundflächenangaben der Ertragstafeln für den verbleibenden und ausscheidenden Bestand berücksichtigt.

Die vorgegebene Grundfläche des verbleibenden Bestandes ist die Bezugsgröße und definiert den Bestockungsgrad B° von 1,0 für die neuen Ertragstafeln.


### 2.3 Bonitierung
Die Bonitierung der Bestände erfolgt mittels des Bestandesalters und der Oberhöhe (H100) anhand der den Ertragstafeln zugrunde liegenden Bonitätsfächer.
Die Ertragstafeln sind nach absoluten Oberhöhenbonitäten im Alter 100 gegliedert.
Diese absoluten Oberhöhen stehen zu den relativen Ertragsklassen laut Ertragstafelsammlung Schober (1995) in folgenden Beziehungen (siehe Tabelle).


```{r tabelle2_html, echo=FALSE, results="asis"}
cat('
<table class="kable_wrapper lightable-paper" style=\'font-family: "Arial Narrow", arial, helvetica, sans-serif; margin-left: auto; margin-right: auto;\'>
<caption>Die absoluten Oberhöhenbonitäten in den Ertragstafeln und die korrespondierenden relativen Ertragsklassen (gerundet) nach Schober (1995).</caption>
<tbody>
  <tr>
   <td> 

<table>
 <thead>
<tr><th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="2"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Eiche</div></th></tr>
  <tr>
   <th style="text-align:center;"> H<sub>100</sub> </th>
   <th style="text-align:center;"> Ekl. </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:center;"> 33 </td>
   <td style="text-align:center;"> -I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 30 </td>
   <td style="text-align:center;"> 0 </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 27 </td>
   <td style="text-align:center;"> I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 24 </td>
   <td style="text-align:center;"> II </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 21 </td>
   <td style="text-align:center;"> III </td>
  </tr>
</tbody>
</table>

 </td>
   <td> 

<table>
 <thead>
<tr><th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="2"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Buche</div></th></tr>
  <tr>
   <th style="text-align:center;"> H<sub>100</sub> </th>
   <th style="text-align:center;"> Ekl. </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:center;"> 40.5 </td>
   <td style="text-align:center;"> -I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 36.5 </td>
   <td style="text-align:center;"> 0 </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 32.5 </td>
   <td style="text-align:center;"> I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 28.5 </td>
   <td style="text-align:center;"> II </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 24.5 </td>
   <td style="text-align:center;"> III </td>
  </tr>
</tbody>
</table>

 </td>
   <td> 

<table>
 <thead>
<tr><th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="2"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Fichte</div></th></tr>
  <tr>
   <th style="text-align:center;"> H<sub>100</sub> </th>
   <th style="text-align:center;"> Ekl. </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:center;"> 43 </td>
   <td style="text-align:center;"> -I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 39 </td>
   <td style="text-align:center;"> 0 </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 35 </td>
   <td style="text-align:center;"> I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 31 </td>
   <td style="text-align:center;"> II </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 27 </td>
   <td style="text-align:center;"> III </td>
  </tr>
</tbody>
</table>

 </td>
   <td> 

<table>
 <thead>
<tr><th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="2"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Douglasie</div></th></tr>
  <tr>
   <th style="text-align:center;"> H<sub>100</sub> </th>
   <th style="text-align:center;"> Ekl. </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:center;"> &nbsp; </td>
   <td style="text-align:center;"> &nbsp; </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 50 </td>
   <td style="text-align:center;"> 0 </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 45 </td>
   <td style="text-align:center;"> I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 40 </td>
   <td style="text-align:center;"> II </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 35 </td>
   <td style="text-align:center;"> III </td>
  </tr>
</tbody>
</table>

 </td>
   <td> 

<table>
 <thead>
<tr><th style="border-bottom:hidden;padding-bottom:0; padding-left:3px;padding-right:3px;text-align: center; " colspan="2"><div style="border-bottom: 1px solid #ddd; padding-bottom: 5px; ">Kiefer</div></th></tr>
  <tr>
   <th style="text-align:center;"> H<sub>100</sub> </th>
   <th style="text-align:center;"> Ekl. </th>
  </tr>
 </thead>
<tbody>
  <tr>
   <td style="text-align:center;"> 37 </td>
   <td style="text-align:center;"> -I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 33 </td>
   <td style="text-align:center;"> 0 </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 29 </td>
   <td style="text-align:center;"> I </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 25 </td>
   <td style="text-align:center;"> II </td>
  </tr>
  <tr>
   <td style="text-align:center;"> 21 </td>
   <td style="text-align:center;"> III </td>
  </tr>
</tbody>
</table>

 </td>
  </tr>
</tbody>
</table>
')
```


## 3.	Ertragstafelaufbau und Anwendungsvoraussetzungen
Die Ertragstafeln sind nach den klassischen Vorbildern aufgebaut.
Für verschiedene absolute Oberhöhenbonitäten sind die Entwicklungen der ertragskundlichen Bestandeskennwerte, getrennt nach verbleibendem und ausscheidendem Bestand, in Fünfjahresschritten dargestellt.
Die Angaben beginnen mit der Fünfjahres-Altersperiode, in der der Bestand eine Oberhöhe (H100) von 11 m erreicht bzw. überschritten hat und erstmals durchforstet wird.
Die Angaben enden, wenn die Endnutzung mit Aufkommen zielstarker Bäume einsetzt oder die festgesetzte Altersobergrenze der Tafeln erreicht ist (Eiche = 180 Jahre, Buche = 150 Jahre, Fichte = 120 Jahre, Douglasie = 120 Jahre, Kiefer = 120 Jahre).

Die Angaben des laufenden Zuwachses beziehen sich auf die der Zeile vorhergehende Fünf-Jahres-Periode, z. B. entspricht der in der Ertragstafel Eiche, Oberhöhenbonität 30, im Alter 50 angegebene laufende Volumenzuwachs von 11,5 m³/ha/J einem 5-jährigen periodischen Zuwachs von 57,5 m³/ha in der Altersperiode 45 bis 50.
Dieser Bezug auf den Beginn der Zuwachsperiode entspricht den Angaben der Fichten-Ertragstafel von Wiedemann (1936/42), während sich der laufende Zuwachs in der Buchen-Ertragstafel von Schober (1967) jeweils auf die folgende Fünf-Jahres-Periode bezieht.

Bei der Anwendung der Ertragstafeln kann zwischen den Oberhöhenbonitäten und den Altern linear interpoliert werden.
Für Angaben außerhalb der in den Ertragstafeln aufgespannten Bonitäts- und Altersrahmen sind die Möglichkeiten der linearen Extrapolation begrenzt.

Die Ertragstafeln sind für gleichaltrige, vollbestockte Reinbestände konzipiert.
Je stärker die realen Bestände von dieser Norm abweichen, desto ungenauer sind die Ertragstafelschätzungen.

Bei Abweichungen vom unterstellten Bestockungsgrad B°=1,0 (Grundflächenhaltung der gestaffelten Hochdurchforstung) sind die Zuwachskorrekturfaktoren anzuwenden, um den aus abweichenden Bestandesdichten resultierenden Mehr- bzw. Minderzuwachs zu berücksichtigen. 

Auch Baumartenmischungen können zu signifikanten Mehr- bzw. Minderzuwächsen des Gesamtbestandes führen.
Je intensiver die Mischungsform ist (Einzelmischung, trupp- bzw. gruppenweise Mischung), desto ungenauer sind die Ertragstafelschätzungen für die jeweiligen ideellen Anteilflächen der Mischbaumarten. 

Aufgrund der sich rapide verändernden Standortsbedingungen sollten die Ertragstafeln nicht für langfristige Planungen bzw. Prognosezeiträume > 20 Jahre verwendet werden.
Anwendungen über diesen Zeitraum hinaus können ggf. zu deutlichen Abweichungen zwischen den in der Ertragstafel unterstellten Standort-Leistungsbeziehungen und deren künftiger Dynamik führen.


## Förderung
Die Entwicklung der neuen Ertragstafeln wurde mit Mitteln des Bundesministeriums für Ernährung und Landwirtschaft (Förderkennzeichen 22027816) von der FNR gefördert.
Die Verantwortung für den Inhalt dieser Veröffentlichung liegt bei den Autoren.


## Literatur
Assmann E. (1961): Waldertragskunde: Organische Produktion, Struktur, Zuwachs und Ertrag von Waldbeständen. München: BLV Verlagsgesellschaft.

Assmann E., Franz F. (1963): Vorläufige Fichten-Ertragstafel für Bayern. Institut für Ertragskunde der Forstlichen Forschungsanstalt, München. 104 S.

Bergel D. (1985): Ertragstafel für Douglasie. In: Schober, R. (Hrsg.): Ertragstafeln wichtiger Baumarten. 4. Aufl., Frankfurt am Main: J. D. Sauerländer`s Verlag, 1995.

Böckmann T. (1990): Wachstum und Ertrag der Winterlinde (Tilia cordata Mill.) in Niedersachsen und Nordhessen. Dissertation, Universität Göttingen. 143 S.

Dittmar O., Knapp E., Lembcke, G. (1986): DDR-Buchenertragstafel 1983. IFE-Berichte aus Forschung und Entwicklung 4.

Ganghofer A. (1881): Das forstliche Versuchswesen. Band 1. Augsburg.

Gehrhardt E. (1923): Ertragstafeln für Eiche, Buche, Tanne, Fichte und Kiefer. Berlin: Springer. 

Hansen J., Nagel J. (2014): Waldwachstumskundliche Softwaresysteme auf Basis von TreeGrOSS: Anwendung und theoretische Grundlagen. Beiträge aus der Nordwestdeutschen Forstlichen Versuchsanstalt, Bd. 11. Universitätsverlag Göttingen. 224 S.

Lockow K.-W. (2003): Bergahorn (Acer pseudoplatanus L.) im norddeutschen Tiefland. Ertragstafel. Landesforstanstalt Eberswalde.

Nagel J. (1985): Wachstumsmodelle für Bergahorn in Schleswig-Holstein. Dissertation, Universität Göttingen. 124 S.

NW-FVA (2021): Merkblätter, Entscheidungshilfen und Leitfäden. https://www.nw-fva.de/veroeffentlichen/merkblaetter (Zugriff am 05.10.2022)

Paulsen J. Ch. (1795): Praktische Anweisung zum Forstwesen. Detmold.

Röhe P., Lockow K.-W., Noack M. (2019): Ertragstafel für die Stieleiche (Quercus robur L.). Landesforst Mecklenburg-Vorpommern (Hrsg.). cw Nordwest Media Verlagsgesellschaft.

Schwappach A. (1902): Wachstum und Ertrag normaler Fichtenbestände in Preußen unter besonderer Berücksichtigung des Einflusses verschiedener wirtschaftlicher Behandlungsweisen. In: Mitteilungen des Forstlichen Versuchswesens Preußens, S. 44–119.

Schober R. (1975): Ertragstafeln wichtiger Baumarten bei verschiedener Durchforstung. Neubearb. Frankfurt a.M., J.D. Sauerländer’s Verlag.

Schober R. (1967): Ertragstafel für die Baumart Buche (mäßige und starke Durchforstung). In: Schober R. (Hrsg.): Ertragstafeln wichtiger Baumarten. 4. Aufl., Frankfurt a.M., J. D. Sauerländer`s Verlag, 1995.

Schober R. (1995): Ertragstafeln wichtiger Baumarten. 4. Aufl., Frankfurt a.M., J. D. Sauerländer‘s Verlag.

Sprauer S., Nagel J. (2018): Neuparametrisierung des Grundflächenzuwachsmodells in TreeGrOSS mit Versuchsflächendaten ab 1970. NW-FVA unveröffentlicht.

Wenk G., Römisch K., Gerold D. (1984): DDR-Fichtenertragstafel. Agrarwissenschaftliche Gesellschaft der DDR, Dresden.

Wiedemann E. (1936/42): Ertragstafel für die Baumart Fichte (mäßige, starke und gestaffelte Durchforstung). In: Schober R. (Hrsg.): Ertragstafeln wichtiger Baumarten bei verschiedener Durchforstung. 4. Aufl., Frankfurt a.M., J. D. Sauerländer`s Verlag, 1995.

Wiedemann E. (1949): Ertragstafeln der wichtigen Holzarten bei verschiedener Durchforstung. Verlag Schaper, Hannover. 100 S.
